package br.usp.ime.mac5855.knn;

/**
 * @author Victor Williams Stafusa da Silva
 */
public abstract class EscalonadorMultiplicativo<E> implements Escalonador<E> {

    private final double[] pesos;

    public EscalonadorMultiplicativo(double[] pesos) {
        if (pesos == null) {
            throw new IllegalArgumentException("O array de dimenses no pode ser null.");
        }
        if (pesos.length < 1) {
            throw new IllegalArgumentException("O nmero de dimenses deve ser pelo menos 1.");
        }
        this.pesos = pesos;
    }

    public double[] getPesos() {
        return pesos;
    }

    @Override
    public double peso(int numDimensao, double valorOriginal) {
        return valorOriginal * pesos[numDimensao];
    }
}