package br.usp.ime.mac5855.knn;

/**
 * @author Victor Williams Stafusa da Silva
 */
public abstract class EscalonadorUniforme<E> implements Escalonador<E> {

    private final int numDimensoes;

    public EscalonadorUniforme(int numDimensoes) {
        if (numDimensoes < 1) {
            throw new IllegalArgumentException("O nmero de dimenses deve ser pelo menos 1.");
        }
        this.numDimensoes = numDimensoes;
    }

    public int getNumDimensoes() {
        return numDimensoes;
    }

    @Override
    public double peso(int numDimensao, double valorOriginal) {
        return valorOriginal;
    }
}