package br.usp.ime.mac5855.knn;

/**
 * @author Victor Williams Stafusa da Silva
 */
public final class PonderadorGaussiano implements PonderadorKnn {

    private final double denominadorExpoente;

    private static final double SIGMA_DEFAULT = 10.0;

    public PonderadorGaussiano() {
        this(SIGMA_DEFAULT);
    }

    public PonderadorGaussiano(double sigma) {
        if (sigma <= 0.0) throw new IllegalArgumentException("O sigma no pode ser menor ou igual a zero.");
        this.denominadorExpoente = sigma * sigma * 2.0;
    }

    @Override
    public double ponderar(double valor) {
        return Math.exp((-valor * valor) / denominadorExpoente);
    }
}