package br.usp.ime.mac5855.knn;

/**
 * @author Victor Williams Stafusa da Silva
 */
public final class PonderadorInverso implements PonderadorKnn {

    private final double constanteDenominador;
    private final double numerador;

    private static final double NUMERADOR_DEFAULT = 1.0;
    private static final double CONSTANTE_DENOMINADOR_DEFAULT = 0.1;

    public PonderadorInverso() {
        this(NUMERADOR_DEFAULT, CONSTANTE_DENOMINADOR_DEFAULT);
    }

    public PonderadorInverso(double numerador, double constanteDenominador) {
        if (constanteDenominador < 0.0) {
            throw new IllegalArgumentException("O denominador no pode ser negativo.");
        }
        this.numerador = numerador;
        this.constanteDenominador = constanteDenominador;
    }

    @Override
    public double ponderar(double valor) {
        return numerador / (constanteDenominador + valor);
    }
}
