package br.usp.ime.mac5855.knn.validacaocruzada;

import java.util.Random;

/**
 * @author Victor Williams Stafusa da Silva
 */
public final class ValidacaoCruzadaStrategyQuadratico implements ValidacaoCruzadaStrategy {

    private final Random random;

    public ValidacaoCruzadaStrategyQuadratico() {
        this.random = new Random();
    }

    public ValidacaoCruzadaStrategyQuadratico(long seed) {
        this.random = new Random(seed);
    }

    @Override
    public double avaliarErro(double valorEstimado, double valorReal) {
        double diferenca = valorEstimado - valorReal;
        return diferenca * diferenca;
    }

    @Override
    public Random random() {
        return random;
    }
}