package br.usp.ime.mac5855.testeknn;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

/**
 * @author Victor Williams Stafusa dda Silva
 */
public class RandomPizzaFactory {

    private final boolean possivelmenteVip;
    private final Random random;

    public RandomPizzaFactory(Random random, boolean possivelmenteVip) {
        this.possivelmenteVip = possivelmenteVip;
        this.random = random;
    }

    private double randomGaussian(double sigma) {
        double valor = random.nextGaussian() * sigma;
        long vtrunc = (long) (valor * 100.0);
        return ((double) vtrunc) / 100;
    }

    private double randomDouble(double mult) {
        double valor = random.nextDouble() * mult;
        long vtrunc = (long) (valor * 100.0);
        return ((double) vtrunc) / 100;
    }

    public Pizza obterPizza() {
        Pizza p = new Pizza();

        p.azeitonas = random.nextInt(3) == 0 ? 0 : random.nextInt(6) + 5; // 5 a 10 azeitonas, ou nenhuma.
        p.rodelasTomate = random.nextInt(3) == 0 ? 0 : random.nextInt(6) + 5; // 5 a 10 rodelas de tomate, ou nenhuma.
        p.gramasMussarela = randomDouble(200) + 50; // 50 a 250 gramas de mussarela.
        p.gramasPresunto = randomDouble(200) + 50; // 50 a 250 gramas de presunto.
        p.tamanhoSapatoPizzaiolo = (int) (randomGaussian(5.0) + 38);
        p.valorIngredientesEspeciais = randomDouble(1);
        if (possivelmenteVip) p.pizzaVip = (random.nextInt(2) == 0);
        p.gerarPreco(random);

        return p;
    }

    public List<Pizza> obterPizzas(int quantidade) {
        List<Pizza> pizzas = new ArrayList<Pizza>(quantidade);
        for (int i = 0; i < quantidade; i++) {
            pizzas.add(obterPizza());
        }
        return pizzas;
    }

    public Map<Pizza, Double> obterPizzasComPreco(int quantidade) {
        Map<Pizza, Double> pizzas = new HashMap<Pizza, Double>(quantidade);
        for (int i = 0; i < quantidade; i++) {
            Pizza p = obterPizza();
            pizzas.put(p, p.preco);
        }
        return pizzas;
    }
}
